## Plone Web Mail
## Copyright (C) 2003, 1000 ASA, http://www.1000asa.com
## Maintained by Giorgio Pieretti <giorgio at 1000asa.com>
## Released under GPL version 2
## See LICENSE.txt or http://www.gnu.org/copyleft/gpl.html


from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from Globals import Persistent    # makes an object stick in the ZODB
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFCore.WorkflowCore import WorkflowAction
from OFS.PropertyManager import PropertyManager
from OFS.SimpleItem import SimpleItem 
import string


# PloneWebMail_addressbook definition
factory_type_information = {
  'id'             : 'PloneWebMail_addressbook',
  'title'          : 'Addressbook',
  'portal_type'    : 'PloneWebMail_addressbook',
  'meta_type'      : 'PloneWebMail_addressbook',
  'description'    : 'Plone Web Mail AddressBook',
  'content_icon'   : 'PloneWebMail_addressbook.png',
  'product'        : 'PloneWebMail',
  'factory'        : 'addPloneWebMail_addressbook',
  'immediate_view' : 'PloneWebMail_addressbook_view',
  'global_allow'   : 0,
  'actions': (
    {
    'id'           : 'view',
    'name'         : 'View',
    'action'       : 'PloneWebMail_addressbook_view',
    'permissions'  : (CMFCorePermissions.View, ),
    'category'      : 'object',
    },
  ),
  }

def addPloneWebMail_addressbook(self, id, title = '', card=[]):
    """Add a PloneWebMail_addressbook."""
    obj = PloneWebMail_addressbook(id, title, card)
    self._setObject(id, obj)



class PloneWebMail_addressbook(SimpleItem, PortalContent, PropertyManager):
    
    meta_type = factory_type_information['meta_type']
    portal_type = factory_type_information['meta_type']
    security = ClassSecurityInfo()
    security.declareObjectPublic()

    _properties=(
        {'id':'AddressbookData','type':'text'},
    )
    manage_options = (PropertyManager.manage_options + SimpleItem.manage_options)
    
    AddressbookData = ''
    
    def __init__(self, id, title='', AddressbookData=''):
        self.id = id
        self.title = title
        if not self.__dict__.has_key('AddressbookData'):
            self.__dict__['AddressbookData'] = self.AddressbookData

   
	    
	    
    def csv2list(self):
        """ return the list obj of the current addressbook """
        if self.AddressbookData == '' : return None
	CRsplit = self.AddressbookData.split('\n')
	if CRsplit[-1] == '': CRsplit.pop(-1)
	return CRsplit
	    
    def list2dict(self, lista=None):
        """ return the list obj of the current addressbook """
        if lista == None : return None
	dict = {}
	new_lista = []
	for i in lista:
	    item = i.split(',')
	    new_lista.append({'lastname':item[0],'firstname':item[1],'email':item[4]})
	return new_lista

    def edit(self, AddressbookData):
        """Change the instance's properties """
        self.AddressbookData=AddressbookData

    edit = WorkflowAction(edit)


InitializeClass(PloneWebMail_addressbook)