## Plone Web Mail
## Copyright (C) 2004, OPENPROJECTS, http://openprojects.it
## Maintained by Giorgio Pieretti <giorgio.pieretti at openprojects.it>
## Released under GPL version 2
## See LICENSE.txt or http://www.gnu.org/copyleft/gpl.html


from Products.CMFDefault import SkinnedFolder
from AccessControl import ClassSecurityInfo
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFCore.WorkflowCore import WorkflowAction
from Products.CMFCore import CMFCorePermissions
from PloneWebMail_addressbook import PloneWebMail_addressbook, addPloneWebMail_addressbook
from Globals import InitializeClass 



# PloneWebMail_box definition
factory_type_information = {
  'id'             : 'PloneWebMail_box',
  'title'          : 'Email account',
  'meta_type'      : 'PloneWebMail_box',
  'portal_type'    : 'PloneWebMail_box',
  'description'    : 'Email account box',
  'content_icon'   : 'PloneWebMail_box.png',
  'product'        : 'PloneWebMail',
  'factory'        : 'addPloneWebMail_box',
  'immediate_view' : 'view',
  'actions': (
    {
    'id'           : 'view',
    'name'         : 'View',
    'action'       : 'PloneWebMail_box_view',
    'permissions'  : (CMFCorePermissions.View, ),
    },
    {
    'id'           : 'edit',
    'name'         : 'Edit',
    'action'       : 'PloneWebMail_box_edit_form',
    'permissions'  : (CMFCorePermissions.ModifyPortalContent,),
    },
  ),
  }

security = ClassSecurityInfo()


security.declareProtected("Add PloneWebMail_box", 'addPloneWebMail_box')
def addPloneWebMail_box(self, id, REQUEST=None):
    """ Create an empty box with personal_addressbook"""
    dat = self.objectIds('PloneWebMail_addressbook')
    if 'personal_addressbook' not in dat:
       self.manage_addProduct['PloneWebMail'].addPloneWebMail_addressbook(id='personal_addressbook',title='PloneWebMail personal addressbook')
    obj = PloneWebMail_box(id)
    self._setObject(id, obj)




class PloneWebMail_box(SkinnedFolder.SkinnedFolder, PortalContent, DefaultDublinCoreImpl,):
    """PloneWebMail account class"""
    meta_type = 'PloneWebMail_box'
    portal_type = 'PloneWebMail_box'
    _isDiscussable = 0
    effective_date = expiration_date = None

    # Init method
    def __init__(self, id, title=''):
        """__init__(self, id, title='')"""
        self.id = id
	self.title = title
	self.mailserver=''
        self.mailserver_smtp=''
        self.mailserver_type=''
        self.username=''
        self.password=''
	self.account_email=''
	self.account_name=''
	self.mailbox_inbox='INBOX'
	self.mailbox_trash='Trash'
	self.mailbox_sent='Sent'


    def manage_afterAdd(self, item,container):
        item.manage_permission(CMFCorePermissions.View, ('Manager', 'Owner'),0)
        item.manage_permission(CMFCorePermissions.AccessContentsInformation, ('Manager', 'Owner'),0)



    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'edit')
    def edit(self, mailserver, mailserver_smtp, mailserver_type, username, password, account_email, account_name, mailbox_inbox, mailbox_trash, mailbox_sent):
        """Change the instance's properties """
        self.mailserver=mailserver
        self.mailserver_smtp=mailserver_smtp
        self.mailserver_type=mailserver_type
        self.username=username
        self.password=password
	self.account_email=account_email
	self.account_name=account_name
	self.mailbox_inbox=mailbox_inbox
	self.mailbox_trash=mailbox_trash
	self.mailbox_sent=mailbox_sent

    edit = WorkflowAction(edit)



InitializeClass(PloneWebMail_box) 